diff -Naur --no-dereference a/drivers/media/platform/chips-media/wave5/wave5-hw.c b/drivers/media/platform/chips-media/wave5/wave5-hw.c
--- a/drivers/media/platform/chips-media/wave5/wave5-hw.c	2025-06-19 09:32:38.000000000 -0400
+++ b/drivers/media/platform/chips-media/wave5/wave5-hw.c	2025-10-23 09:30:40.285462207 -0400
@@ -40,6 +40,16 @@
 
 #define FASTIO_ADDRESS_MASK		GENMASK(15, 0)
 #define SEQ_PARAM_PROFILE_MASK		GENMASK(30, 24)
+#define SEQ_BG_PARAM_REG_DATA		0x3800410
+
+#define ENC_AVC_INTRA_IDR_PARAM_MASK	0x7ff
+#define ENC_AVC_INTRA_PERIOD_SHIFT		6
+#define ENC_AVC_IDR_PERIOD_SHIFT		17
+#define ENC_AVC_FORCED_IDR_HEADER_SHIFT		28
+
+#define ENC_HEVC_INTRA_QP_SHIFT			3
+#define ENC_HEVC_FORCED_IDR_HEADER_SHIFT	9
+#define ENC_HEVC_INTRA_PERIOD_SHIFT		16
 
 static void _wave5_print_reg_err(struct vpu_device *vpu_dev, u32 reg_fail_reason,
 				 const char *func);
@@ -93,7 +103,7 @@
 		dev_dbg(dev, "%s: queueing failure: 0x%x\n", func, reg_val);
 		break;
 	case WAVE5_SYSERR_RESULT_NOT_READY:
-		dev_err(dev, "%s: result not ready: 0x%x\n", func, reg_fail_reason);
+		dev_dbg(dev, "%s: result not ready: 0x%x\n", func, reg_fail_reason);
 		break;
 	case WAVE5_SYSERR_ACCESS_VIOLATION_HW:
 		dev_err(dev, "%s: access violation: 0x%x\n", func, reg_fail_reason);
@@ -185,6 +195,19 @@
 	return vpu_read_reg(vpu_dev, W5_VCPU_CUR_PC) != 0;
 }
 
+static dma_addr_t wave5_read_reg_for_mem_addr(struct vpu_instance *inst,
+					      unsigned int reg_addr)
+{
+	dma_addr_t addr;
+	dma_addr_t high_addr = inst->dev->ext_addr;
+	u32 val;
+
+	val = vpu_read_reg(inst->dev, reg_addr);
+	addr = ((high_addr << 32) | val);
+
+	return addr;
+}
+
 unsigned int wave5_vpu_get_product_id(struct vpu_device *vpu_dev)
 {
 	u32 val = vpu_read_reg(vpu_dev, W5_PRODUCT_NUMBER);
@@ -466,7 +489,8 @@
 	vpu_write_reg(vpu_dev, W5_HW_OPTION, 0);
 
 	if (vpu_dev->product_code != WAVE515_CODE) {
-		wave5_fio_writel(vpu_dev, W5_BACKBONE_PROC_EXT_ADDR, 0);
+		reg_val = (vpu_dev->ext_addr & 0xFFFF);
+		wave5_fio_writel(vpu_dev, W5_BACKBONE_PROC_EXT_ADDR, reg_val);
 		wave5_fio_writel(vpu_dev, W5_BACKBONE_AXI_PARAM, 0);
 		vpu_write_reg(vpu_dev, W5_SEC_AXI_PARAM, 0);
 	}
@@ -572,7 +596,7 @@
 
 	if (inst->dev->product_code != WAVE515_CODE) {
 		/* This register must be reset explicitly */
-		vpu_write_reg(inst->dev, W5_CMD_EXT_ADDR, 0);
+		vpu_write_reg(inst->dev, W5_CMD_EXT_ADDR, inst->dev->ext_addr);
 		vpu_write_reg(inst->dev, W5_CMD_NUM_CQ_DEPTH_M1,
 			      WAVE521_COMMAND_QUEUE_DEPTH - 1);
 	}
@@ -1160,7 +1184,8 @@
 		vpu_write_reg(vpu_dev, W5_HW_OPTION, 0);
 
 		if (vpu_dev->product_code != WAVE515_CODE) {
-			wave5_fio_writel(vpu_dev, W5_BACKBONE_PROC_EXT_ADDR, 0);
+			reg_val = (vpu_dev->ext_addr & 0xFFFF);
+			wave5_fio_writel(vpu_dev, W5_BACKBONE_PROC_EXT_ADDR, reg_val);
 			wave5_fio_writel(vpu_dev, W5_BACKBONE_AXI_PARAM, 0);
 			vpu_write_reg(vpu_dev, W5_SEC_AXI_PARAM, 0);
 		}
@@ -1219,7 +1244,7 @@
 	return setup_wave5_properties(dev);
 }
 
-static int wave5_vpu_sleep_wake(struct device *dev, bool i_sleep_wake, const uint16_t *code,
+int wave5_vpu_sleep_wake(struct device *dev, bool i_sleep_wake, const uint16_t *code,
 				size_t size)
 {
 	u32 reg_val;
@@ -1285,7 +1310,8 @@
 		vpu_write_reg(vpu_dev, W5_HW_OPTION, 0);
 
 		if (vpu_dev->product_code != WAVE515_CODE) {
-			wave5_fio_writel(vpu_dev, W5_BACKBONE_PROC_EXT_ADDR, 0);
+			reg_val = (vpu_dev->ext_addr & 0xFFFF);
+			wave5_fio_writel(vpu_dev, W5_BACKBONE_PROC_EXT_ADDR, reg_val);
 			wave5_fio_writel(vpu_dev, W5_BACKBONE_AXI_PARAM, 0);
 			vpu_write_reg(vpu_dev, W5_SEC_AXI_PARAM, 0);
 		}
@@ -1520,7 +1546,7 @@
 	if (ret)
 		return inst->codec_info->dec_info.stream_rd_ptr;
 
-	return vpu_read_reg(inst->dev, W5_RET_QUERY_DEC_BS_RD_PTR);
+	return wave5_read_reg_for_mem_addr(inst, W5_RET_QUERY_DEC_BS_RD_PTR);
 }
 
 int wave5_dec_set_rd_ptr(struct vpu_instance *inst, dma_addr_t addr)
@@ -1571,7 +1597,7 @@
 
 	reg_val = (open_param->line_buf_int_en << 6) | BITSTREAM_ENDIANNESS_BIG_ENDIAN;
 	vpu_write_reg(inst->dev, W5_CMD_BS_PARAM, reg_val);
-	vpu_write_reg(inst->dev, W5_CMD_EXT_ADDR, 0);
+	vpu_write_reg(inst->dev, W5_CMD_EXT_ADDR, inst->dev->ext_addr);
 	vpu_write_reg(inst->dev, W5_CMD_NUM_CQ_DEPTH_M1, WAVE521_COMMAND_QUEUE_DEPTH - 1);
 
 	/* This register must be reset explicitly */
@@ -1753,6 +1779,9 @@
 			(p_param->skip_intra_trans << 25) |
 			(p_param->strong_intra_smooth_enable << 27) |
 			(p_param->en_still_picture << 30);
+	else if (inst->std == W_AVC_ENC)
+		reg_val |= (p_param->constraint_set1_flag << 29);
+
 	vpu_write_reg(inst->dev, W5_CMD_ENC_SEQ_SPS_PARAM, reg_val);
 
 	reg_val = (p_param->lossless_enable) |
@@ -1772,12 +1801,14 @@
 
 	if (inst->std == W_AVC_ENC)
 		vpu_write_reg(inst->dev, W5_CMD_ENC_SEQ_INTRA_PARAM, p_param->intra_qp |
-				((p_param->intra_period & 0x7ff) << 6) |
-				((p_param->avc_idr_period & 0x7ff) << 17));
+				((p_param->intra_period & ENC_AVC_INTRA_IDR_PARAM_MASK) << ENC_AVC_INTRA_PERIOD_SHIFT) |
+				((p_param->avc_idr_period & ENC_AVC_INTRA_IDR_PARAM_MASK) << ENC_AVC_IDR_PERIOD_SHIFT) |
+				(p_param->forced_idr_header_enable << ENC_AVC_FORCED_IDR_HEADER_SHIFT));
 	else if (inst->std == W_HEVC_ENC)
 		vpu_write_reg(inst->dev, W5_CMD_ENC_SEQ_INTRA_PARAM,
-			      p_param->decoding_refresh_type | (p_param->intra_qp << 3) |
-				(p_param->intra_period << 16));
+				p_param->decoding_refresh_type | (p_param->intra_qp << ENC_HEVC_INTRA_QP_SHIFT) |
+				(p_param->forced_idr_header_enable << ENC_HEVC_FORCED_IDR_HEADER_SHIFT) |
+				(p_param->intra_period << ENC_HEVC_INTRA_PERIOD_SHIFT));
 
 	reg_val = (p_param->rdo_skip << 2) |
 		(p_param->lambda_scaling_enable << 3) |
@@ -1822,7 +1853,7 @@
 	vpu_write_reg(inst->dev, W5_CMD_ENC_SEQ_RC_BIT_RATIO_LAYER_4_7, 0);
 	vpu_write_reg(inst->dev, W5_CMD_ENC_SEQ_ROT_PARAM, rot_mir_mode);
 
-	vpu_write_reg(inst->dev, W5_CMD_ENC_SEQ_BG_PARAM, 0);
+	vpu_write_reg(inst->dev, W5_CMD_ENC_SEQ_BG_PARAM, SEQ_BG_PARAM_REG_DATA | p_param->bg_detection);
 	vpu_write_reg(inst->dev, W5_CMD_ENC_SEQ_CUSTOM_LAMBDA_ADDR, 0);
 	vpu_write_reg(inst->dev, W5_CMD_ENC_SEQ_CONF_WIN_TOP_BOT,
 		      p_param->conf_win_bot << 16 | p_param->conf_win_top);
@@ -2139,6 +2170,18 @@
 	return ret;
 }
 
+int wave5_vpu_enc_apply_change_param(struct vpu_instance *inst, u32 *fail_res)
+{
+	/* SET_PARAM + COMMON */
+	vpu_write_reg(inst->dev, W5_CMD_ENC_SEQ_SET_PARAM_OPTION, OPT_CHANGE_PARAM);
+	vpu_write_reg(inst->dev, W5_CMD_ENC_SEQ_SET_PARAM_ENABLE, inst->change_param_flags);
+
+	if (inst->change_param_flags & W5_ENC_CHANGE_PARAM_RC_TARGET_RATE)
+		vpu_write_reg(inst->dev, W5_CMD_ENC_SEQ_RC_TARGET_RATE, inst->bit_rate);
+
+	return send_firmware_command(inst, W5_ENC_SET_PARAM, true, NULL, fail_res);
+}
+
 int wave5_vpu_encode(struct vpu_instance *inst, struct enc_param *option, u32 *fail_res)
 {
 	u32 src_frame_format;
@@ -2186,7 +2229,11 @@
 			      (option->code_option.encode_eos << 6) |
 			      (option->code_option.encode_eob << 7));
 
-	vpu_write_reg(inst->dev, W5_CMD_ENC_PIC_PIC_PARAM, 0);
+	vpu_write_reg(inst->dev, W5_CMD_ENC_PIC_PIC_PARAM, (option->force_pictype_enable<<20) |
+								(option->force_pic_type<<21));
+
+	option->force_pictype_enable = 0;
+	option->force_pic_type = 0;
 
 	if (option->src_end_flag)
 		/* no more source images. */
@@ -2354,10 +2401,10 @@
 	result->recon_frame_index = vpu_read_reg(inst->dev, W5_RET_ENC_PIC_IDX);
 	result->enc_pic_byte = vpu_read_reg(inst->dev, W5_RET_ENC_PIC_BYTE);
 	result->enc_src_idx = vpu_read_reg(inst->dev, W5_RET_ENC_USED_SRC_IDX);
-	p_enc_info->stream_wr_ptr = vpu_read_reg(inst->dev, W5_RET_ENC_WR_PTR);
-	p_enc_info->stream_rd_ptr = vpu_read_reg(inst->dev, W5_RET_ENC_RD_PTR);
+	p_enc_info->stream_wr_ptr = wave5_read_reg_for_mem_addr(inst, W5_RET_ENC_WR_PTR);
+	p_enc_info->stream_rd_ptr = wave5_read_reg_for_mem_addr(inst, W5_RET_ENC_RD_PTR);
 
-	result->bitstream_buffer = vpu_read_reg(inst->dev, W5_RET_ENC_RD_PTR);
+	result->bitstream_buffer = wave5_read_reg_for_mem_addr(inst, W5_RET_ENC_RD_PTR);
 	result->rd_ptr = p_enc_info->stream_rd_ptr;
 	result->wr_ptr = p_enc_info->stream_wr_ptr;
 
diff -Naur --no-dereference a/drivers/media/platform/chips-media/wave5/wave5-vpuapi.c b/drivers/media/platform/chips-media/wave5/wave5-vpuapi.c
--- a/drivers/media/platform/chips-media/wave5/wave5-vpuapi.c	2025-06-19 09:32:38.000000000 -0400
+++ b/drivers/media/platform/chips-media/wave5/wave5-vpuapi.c	2025-10-23 09:30:40.285462207 -0400
@@ -6,6 +6,8 @@
  */
 
 #include <linux/bug.h>
+#include <linux/pm_runtime.h>
+#include <linux/delay.h>
 #include "wave5-vpuapi.h"
 #include "wave5-regdefine.h"
 #include "wave5.h"
@@ -81,6 +83,7 @@
 			ret = mutex_lock_interruptible(&inst->dev->hw_lock);
 			if (ret)
 				return ret;
+
 			if (dec_info.index_frame_display > 0)
 				wave5_vpu_dec_set_disp_flag(inst, dec_info.index_frame_display);
 		}
@@ -210,9 +213,13 @@
 	if (!inst->codec_info)
 		return -EINVAL;
 
+	pm_runtime_resume_and_get(inst->dev->dev);
+
 	ret = mutex_lock_interruptible(&vpu_dev->hw_lock);
-	if (ret)
+	if (ret) {
+		pm_runtime_put_sync(inst->dev->dev);
 		return ret;
+	}
 
 	do {
 		ret = wave5_vpu_dec_finish_seq(inst, fail_res);
@@ -244,7 +251,8 @@
 
 unlock_and_return:
 	mutex_unlock(&vpu_dev->hw_lock);
-
+	mutex_destroy(&inst->feed_lock);
+	pm_runtime_put_sync(inst->dev->dev);
 	return ret;
 }
 
@@ -712,6 +720,8 @@
 	if (!inst->codec_info)
 		return -EINVAL;
 
+	pm_runtime_resume_and_get(inst->dev->dev);
+
 	ret = mutex_lock_interruptible(&vpu_dev->hw_lock);
 	if (ret)
 		return ret;
@@ -746,6 +756,8 @@
 
 	mutex_unlock(&vpu_dev->hw_lock);
 
+	pm_runtime_put_sync(inst->dev->dev);
+
 	return 0;
 }
 
@@ -827,6 +839,21 @@
 	return 0;
 }
 
+int wave5_vpu_enc_change_param(struct vpu_instance *inst, u32 *fail_res)
+{
+	int ret;
+	struct vpu_device *vpu_dev = inst->dev;
+
+	ret = mutex_lock_interruptible(&vpu_dev->hw_lock);
+	if (ret)
+		return ret;
+
+	ret = wave5_vpu_enc_apply_change_param(inst, fail_res);
+	mutex_unlock(&vpu_dev->hw_lock);
+
+	return ret;
+}
+
 int wave5_vpu_enc_start_one_frame(struct vpu_instance *inst, struct enc_param *param, u32 *fail_res)
 {
 	struct enc_info *p_enc_info = &inst->codec_info->enc_info;
diff -Naur --no-dereference a/drivers/media/platform/chips-media/wave5/wave5-vpuapi.h b/drivers/media/platform/chips-media/wave5/wave5-vpuapi.h
--- a/drivers/media/platform/chips-media/wave5/wave5-vpuapi.h	2025-06-19 09:32:38.000000000 -0400
+++ b/drivers/media/platform/chips-media/wave5/wave5-vpuapi.h	2025-10-23 09:30:40.285462207 -0400
@@ -10,6 +10,7 @@
 
 #include <linux/idr.h>
 #include <linux/genalloc.h>
+#include <linux/devfreq.h>
 #include <media/v4l2-device.h>
 #include <media/v4l2-mem2mem.h>
 #include <media/v4l2-ctrls.h>
@@ -48,6 +49,10 @@
 #define WAVE5_DEC_HEVC_BUF_SIZE(_w, _h) (DIV_ROUND_UP(_w, 64) * DIV_ROUND_UP(_h, 64) * 256 + 64)
 #define WAVE5_DEC_AVC_BUF_SIZE(_w, _h) ((((ALIGN(_w, 256) / 16) * (ALIGN(_h, 16) / 16)) + 16) * 80)
 
+#define IS_WRAP(_v, _max) ((_v % _max) ? 1 : 0)
+#define DEC_BUF_OFFSET 3
+#define MAX_TIMESTAMP_CIR_BUF 30
+
 #define WAVE5_FBC_LUMA_TABLE_SIZE(_w, _h) (ALIGN(_h, 64) * ALIGN(_w, 256) / 32)
 #define WAVE5_FBC_CHROMA_TABLE_SIZE(_w, _h) (ALIGN((_h), 64) * ALIGN((_w) / 2, 256) / 32)
 #define WAVE5_ENC_AVC_BUF_SIZE(_w, _h) (ALIGN(_w, 64) * ALIGN(_h, 64) / 32)
@@ -459,6 +464,27 @@
 #define MAX_NUM_SPATIAL_LAYER 3
 #define MAX_GOP_NUM 8
 
+enum enc_change_param {
+	// COMMON parameters which can be changed frame by frame.
+	W5_ENC_CHANGE_PARAM_PPS                 = (1<<0),
+	W5_ENC_CHANGE_PARAM_INTRA_PARAM         = (1<<1),
+	W5_ENC_CHANGE_PARAM_RC_FRAME_RATE       = (1<<6),
+	W5_ENC_CHANGE_PARAM_RC_TARGET_RATE      = (1<<8),
+	W5_ENC_CHANGE_PARAM_RC                  = (1<<9),
+	W5_ENC_CHANGE_PARAM_RC_MIN_MAX_QP       = (1<<10),
+	W5_ENC_CHANGE_PARAM_RC_BIT_RATIO_LAYER  = (1<<11),
+	W5_ENC_CHANGE_PARAM_RC_INTER_MIN_MAX_QP = (1<<12),
+	W5_ENC_CHANGE_PARAM_RC_WEIGHT           = (1<<13),
+	W5_ENC_CHANGE_PARAM_INDEPEND_SLICE      = (1<<16),
+	W5_ENC_CHANGE_PARAM_DEPEND_SLICE        = (1<<17),
+	W5_ENC_CHANGE_PARAM_RDO                 = (1<<18),
+	W5_ENC_CHANGE_PARAM_NR                  = (1<<19),
+	W5_ENC_CHANGE_PARAM_BG                  = (1<<20),
+	W5_ENC_CHANGE_PARAM_CUSTOM_MD           = (1<<21),
+	W5_ENC_CHANGE_PARAM_CUSTOM_LAMBDA       = (1<<22),
+	W5_ENC_CHANGE_PARAM_VUI_HRD_PARAM       = (1<<23),
+};
+
 struct custom_gop_pic_param {
 	u32 pic_type; /* picture type of nth picture in the custom GOP */
 	u32 poc_offset; /* POC of nth picture in the custom GOP */
@@ -568,6 +594,10 @@
 	u32 lambda_scaling_enable: 1; /* enable lambda scaling using custom GOP */
 	u32 transform8x8_enable: 1; /* enable 8x8 intra prediction and 8x8 transform */
 	u32 mb_level_rc_enable: 1; /* enable MB-level rate control */
+	u32 forced_idr_header_enable: 1; /* enable header encoding before IDR frame */
+	u32 constraint_set1_flag: 1; /* enable CBP */
+	u32 forced_idr_pictype_enable: 1;
+	u32 bg_detection: 1; /* enable background detection */
 };
 
 struct enc_open_param {
@@ -611,16 +641,18 @@
 
 struct enc_param {
 	struct frame_buffer *source_frame;
-	u32 pic_stream_buffer_addr;
+	dma_addr_t pic_stream_buffer_addr;
 	u64 pic_stream_buffer_size;
 	u32 src_idx; /* source frame buffer index */
 	struct enc_code_opt code_option;
 	u64 pts; /* presentation timestamp (PTS) of the input source */
 	bool src_end_flag;
+	s32  force_pictype_enable; /* A flag to use a force picture type (WAVE only) */
+	s32  force_pic_type;       /* A force picture type (I, P, B, IDR). It is valid when forcePicTypeEnable is 1. (WAVE only) */
 };
 
 struct enc_output_info {
-	u32 bitstream_buffer;
+	dma_addr_t bitstream_buffer;
 	u32 bitstream_size; /* byte size of encoded bitstream */
 	u32 pic_type: 2; /* <<vpuapi_h_pic_type>> */
 	s32 recon_frame_index;
@@ -667,8 +699,8 @@
 	struct dec_open_param open_param;
 	struct dec_initial_info initial_info;
 	struct dec_initial_info new_seq_info; /* temporal new sequence information */
-	u32 stream_wr_ptr;
-	u32 stream_rd_ptr;
+	dma_addr_t stream_wr_ptr;
+	dma_addr_t stream_rd_ptr;
 	u32 frame_display_flag;
 	dma_addr_t stream_buf_start_addr;
 	dma_addr_t stream_buf_end_addr;
@@ -705,8 +737,8 @@
 struct enc_info {
 	struct enc_open_param open_param;
 	struct enc_initial_info initial_info;
-	u32 stream_rd_ptr;
-	u32 stream_wr_ptr;
+	dma_addr_t stream_rd_ptr;
+	dma_addr_t stream_wr_ptr;
 	dma_addr_t stream_buf_start_addr;
 	dma_addr_t stream_buf_end_addr;
 	u32 stream_buf_size;
@@ -755,7 +787,9 @@
 	struct gen_pool *sram_pool;
 	struct vpu_buf sram_buf;
 	void __iomem *vdb_register;
+	struct devfreq *vpu_devfreq;
 	u32 product_code;
+	u32 ext_addr;
 	struct ida inst_ida;
 	struct clk_bulk_data *clks;
 	struct hrtimer hrtimer;
@@ -764,6 +798,13 @@
 	int vpu_poll_interval;
 	int num_clks;
 	struct reset_control *resets;
+	bool opp_table_detected;
+};
+
+struct timestamp_circ_buf {
+	u64 buf[MAX_TIMESTAMP_CIR_BUF];
+	int head;
+	int tail;
 };
 
 struct vpu_instance;
@@ -801,21 +842,29 @@
 	struct frame_buffer frame_buf[MAX_REG_FRAME];
 	struct vpu_buf frame_vbuf[MAX_REG_FRAME];
 	u32 fbc_buf_count;
+	u32 dst_buf_count; // number of ready buffers for display
 	u32 queued_src_buf_num;
 	u32 queued_dst_buf_num;
 	struct list_head avail_src_bufs;
 	struct list_head avail_dst_bufs;
 	struct v4l2_rect conf_win;
 	u64 timestamp;
+	struct timestamp_circ_buf time_stamp;
 	enum frame_buffer_format output_format;
 	bool cbcr_interleave;
 	bool nv21;
 	bool eos;
+	bool retry;
+	bool empty_queue;
+	int queuing_num;
+	struct mutex feed_lock; /* lock for feeding bitstream buffers */
 	struct vpu_buf bitstream_vbuf;
 	dma_addr_t last_rd_ptr;
 	size_t remaining_consumed_bytes;
 	bool needs_reallocation;
 
+	struct semaphore run_sem;
+	struct task_struct *run_thread;
 	unsigned int min_src_buf_count;
 	unsigned int rot_angle;
 	unsigned int mirror_direction;
@@ -826,7 +875,12 @@
 	unsigned int rc_enable;
 	unsigned int bit_rate;
 	unsigned int encode_aud;
+	unsigned int change_param_flags;
 	struct enc_wave_param enc_param;
+	unsigned int *map_index;
+	dma_addr_t *mapped_dma_addr;
+	unsigned int cap_io_mode;
+	struct mutex inst_lock;
 };
 
 void wave5_vdi_write_register(struct vpu_device *vpu_dev, u32 addr, u32 data);
@@ -856,6 +910,7 @@
 dma_addr_t wave5_vpu_dec_get_rd_ptr(struct vpu_instance *inst);
 int wave5_vpu_dec_reset_framebuffer(struct vpu_instance *inst, unsigned int index);
 int wave5_vpu_dec_give_command(struct vpu_instance *inst, enum codec_command cmd, void *parameter);
+int wave5_vpu_enc_change_param(struct vpu_instance *inst, u32 *fail_res);
 int wave5_vpu_dec_get_bitstream_buffer(struct vpu_instance *inst, dma_addr_t *prd_ptr,
 				       dma_addr_t *pwr_ptr, size_t *size);
 int wave5_vpu_dec_update_bitstream_buffer(struct vpu_instance *inst, size_t size);
diff -Naur --no-dereference a/drivers/media/platform/chips-media/wave5/wave5-vpu.c b/drivers/media/platform/chips-media/wave5/wave5-vpu.c
--- a/drivers/media/platform/chips-media/wave5/wave5-vpu.c	2025-06-19 09:32:38.000000000 -0400
+++ b/drivers/media/platform/chips-media/wave5/wave5-vpu.c	2025-10-23 09:30:40.285462207 -0400
@@ -11,6 +11,9 @@
 #include <linux/firmware.h>
 #include <linux/interrupt.h>
 #include <linux/reset.h>
+#include <linux/pm_runtime.h>
+#include <linux/pm_opp.h>
+#include <linux/devfreq.h>
 #include "wave5-vpu.h"
 #include "wave5-regdefine.h"
 #include "wave5-vpuconfig.h"
@@ -50,17 +53,18 @@
 	u32 seq_done;
 	u32 cmd_done;
 	u32 irq_reason;
-	struct vpu_instance *inst;
+	u32 irq_subreason;
+	struct vpu_instance *inst, *tmp;
 	struct vpu_device *dev = dev_id;
 
 	irq_reason = wave5_vdi_read_register(dev, W5_VPU_VINT_REASON);
 	seq_done = wave5_vdi_read_register(dev, W5_RET_SEQ_DONE_INSTANCE_INFO);
 	cmd_done = wave5_vdi_read_register(dev, W5_RET_QUEUE_CMD_DONE_INST);
+
 	wave5_vdi_write_register(dev, W5_VPU_VINT_REASON_CLR, irq_reason);
 	wave5_vdi_write_register(dev, W5_VPU_VINT_CLEAR, 0x1);
 
-	list_for_each_entry(inst, &dev->instances, list) {
-
+	list_for_each_entry_safe(inst, tmp, &dev->instances, list) {
 		if (irq_reason & BIT(INT_WAVE5_INIT_SEQ) ||
 		    irq_reason & BIT(INT_WAVE5_ENC_SET_PARAM)) {
 			if (dev->product_code == WAVE515_CODE &&
@@ -81,7 +85,9 @@
 		    irq_reason & BIT(INT_WAVE5_ENC_PIC)) {
 			if (cmd_done & BIT(inst->id)) {
 				cmd_done &= ~BIT(inst->id);
-				wave5_vdi_write_register(dev, W5_RET_QUEUE_CMD_DONE_INST,
+				irq_subreason = wave5_vdi_read_register(dev, W5_VPU_VINT_REASON);
+				if (!(irq_subreason & BIT(INT_WAVE5_DEC_PIC)))
+					wave5_vdi_write_register(dev, W5_RET_QUEUE_CMD_DONE_INST,
 							 cmd_done);
 				inst->ops->finish_process(inst);
 			}
@@ -153,6 +159,85 @@
 	return 0;
 }
 
+static int wave5_pm_suspend(struct device *dev)
+{
+	struct vpu_device *vpu = dev_get_drvdata(dev);
+
+	if (pm_runtime_suspended(dev))
+		return 0;
+
+	if (vpu->irq < 0)
+		hrtimer_cancel(&vpu->hrtimer);
+
+	wave5_vpu_sleep_wake(dev, true, NULL, 0);
+	clk_bulk_disable_unprepare(vpu->num_clks, vpu->clks);
+
+	return 0;
+}
+
+static int wave5_pm_resume(struct device *dev)
+{
+	struct vpu_device *vpu = dev_get_drvdata(dev);
+	int ret = 0;
+
+	wave5_vpu_sleep_wake(dev, false, NULL, 0);
+	ret = clk_bulk_prepare_enable(vpu->num_clks, vpu->clks);
+	if (ret) {
+		dev_err(dev, "Enabling clocks, fail: %d\n", ret);
+		return ret;
+	}
+
+	if (vpu->irq < 0 && !hrtimer_active(&vpu->hrtimer))
+		hrtimer_start(&vpu->hrtimer, ns_to_ktime(vpu->vpu_poll_interval * NSEC_PER_MSEC),
+			      HRTIMER_MODE_REL_PINNED);
+
+	return ret;
+}
+
+static const struct dev_pm_ops wave5_pm_ops = {
+	SET_RUNTIME_PM_OPS(wave5_pm_suspend, wave5_pm_resume, NULL)
+};
+
+static int vpu_devfreq_target(struct device *dev, unsigned long *freq, u32 flags)
+{
+	struct vpu_device *vpu = dev_get_drvdata(dev);
+	unsigned long target_freq = *freq;
+	struct dev_pm_opp *opp;
+	unsigned long acq_freq;
+	int ret;
+
+	if (!vpu->opp_table_detected) {
+		dev_err(vpu->dev, "No OPP table in device tree\n");
+		return -EINVAL;
+	}
+
+	opp = dev_pm_opp_find_freq_ceil(vpu->dev, &target_freq);
+	if (IS_ERR(opp)) {
+		opp = dev_pm_opp_find_freq_floor(vpu->dev, &target_freq);
+		if (IS_ERR(opp)) {
+			dev_err(vpu->dev, "Failed to get floor value\n");
+			return -EINVAL;
+		}
+	}
+
+	dev_pm_opp_put(opp);
+	acq_freq = dev_pm_opp_get_freq(opp);
+	ret = dev_pm_opp_set_rate(vpu->dev, acq_freq);
+	if (ret) {
+		dev_err(vpu->dev, "Error setting the clock\n");
+		return ret;
+	}
+
+	return ret;
+}
+
+static struct devfreq_dev_profile vpu_devfreq_profile = {
+	.target = vpu_devfreq_target,
+	.freq_table = NULL,
+	.max_state = 0,
+	.polling_ms = 0,
+};
+
 static int wave5_vpu_probe(struct platform_device *pdev)
 {
 	int ret;
@@ -166,8 +251,8 @@
 		return -EINVAL;
 	}
 
-	/* physical addresses limited to 32 bits */
-	ret = dma_set_mask_and_coherent(&pdev->dev, DMA_BIT_MASK(32));
+	/* physical addresses limited to 48 bits */
+	ret = dma_set_mask_and_coherent(&pdev->dev, DMA_BIT_MASK(48));
 	if (ret) {
 		dev_err(&pdev->dev, "Failed to set DMA mask: %d\n", ret);
 		return ret;
@@ -225,6 +310,7 @@
 		goto err_clk_dis;
 	}
 	dev->product = wave5_vpu_get_product_id(dev);
+	dev->ext_addr = ((dev->common_mem.daddr >> 32) & 0xFFFF);
 
 	dev->irq = platform_get_irq(pdev, 0);
 	if (dev->irq < 0) {
@@ -248,6 +334,23 @@
 		}
 	}
 
+	dev->opp_table_detected = TRUE;
+	ret = dev_pm_opp_of_add_table(&pdev->dev);
+	if (ret == -ENODEV) {
+		dev->opp_table_detected = FALSE;
+		dev_err(&pdev->dev, "OPP table not found in device tree\n");
+	} else if (ret < 0) {
+		dev_err(&pdev->dev, "Invalid OPP table in device tree\n");
+		goto err_vdi_release;
+	} else {
+		dev->vpu_devfreq = devm_devfreq_add_device(&pdev->dev, &vpu_devfreq_profile, "userspace", NULL);
+		if (IS_ERR(dev->vpu_devfreq)) {
+			dev_pm_opp_of_remove_table(&pdev->dev);
+			return PTR_ERR(dev->vpu_devfreq);
+		}
+	}
+
+
 	INIT_LIST_HEAD(&dev->instances);
 	ret = v4l2_device_register(&pdev->dev, &dev->v4l2_dev);
 	if (ret) {
@@ -281,6 +384,12 @@
 		 (match_data->flags & WAVE5_IS_DEC) ? "'DECODE'" : "");
 	dev_info(&pdev->dev, "Product Code:      0x%x\n", dev->product_code);
 	dev_info(&pdev->dev, "Firmware Revision: %u\n", fw_revision);
+
+	pm_runtime_set_autosuspend_delay(&pdev->dev, 5000);
+	pm_runtime_use_autosuspend(&pdev->dev);
+	pm_runtime_enable(&pdev->dev);
+	wave5_vpu_sleep_wake(&pdev->dev, true, NULL, 0);
+
 	return 0;
 
 err_enc_unreg:
@@ -310,6 +419,14 @@
 		hrtimer_cancel(&dev->hrtimer);
 	}
 
+	if (dev->opp_table_detected) {
+		devm_devfreq_remove_device(&pdev->dev, dev->vpu_devfreq);
+		dev_pm_opp_of_remove_table(&pdev->dev);
+	}
+
+	pm_runtime_put_sync(&pdev->dev);
+	pm_runtime_disable(&pdev->dev);
+
 	mutex_destroy(&dev->dev_lock);
 	mutex_destroy(&dev->hw_lock);
 	reset_control_assert(dev->resets);
@@ -337,6 +454,7 @@
 	.driver = {
 		.name = VPU_PLATFORM_DEVICE_NAME,
 		.of_match_table = of_match_ptr(wave5_dt_ids),
+		.pm = &wave5_pm_ops,
 		},
 	.probe = wave5_vpu_probe,
 	.remove_new = wave5_vpu_remove,
diff -Naur --no-dereference a/drivers/media/platform/chips-media/wave5/wave5-vpuconfig.h b/drivers/media/platform/chips-media/wave5/wave5-vpuconfig.h
--- a/drivers/media/platform/chips-media/wave5/wave5-vpuconfig.h	2025-06-19 09:32:38.000000000 -0400
+++ b/drivers/media/platform/chips-media/wave5/wave5-vpuconfig.h	2025-10-23 09:30:40.285462207 -0400
@@ -32,10 +32,29 @@
 
 #define MAX_NUM_INSTANCE                32
 
-#define W5_MIN_ENC_PIC_WIDTH            256
-#define W5_MIN_ENC_PIC_HEIGHT           128
-#define W5_MAX_ENC_PIC_WIDTH            8192
-#define W5_MAX_ENC_PIC_HEIGHT           8192
+#define W5_DEF_DEC_PIC_WIDTH            720U
+#define W5_DEF_DEC_PIC_HEIGHT           480U
+#define W5_MIN_DEC_PIC_8_WIDTH          8U
+#define W5_MIN_DEC_PIC_8_HEIGHT         8U
+#define W5_MIN_DEC_PIC_32_WIDTH         32U
+#define W5_MIN_DEC_PIC_32_HEIGHT        32U
+#define W5_MAX_DEC_PIC_WIDTH            8192U
+#define W5_MAX_DEC_PIC_HEIGHT           4320U
+#define W5_DEC_CODEC_STEP_WIDTH         1U
+#define W5_DEC_CODEC_STEP_HEIGHT        1U
+#define W5_DEC_RAW_STEP_WIDTH           32U
+#define W5_DEC_RAW_STEP_HEIGHT          16U
+
+#define W5_DEF_ENC_PIC_WIDTH            416U
+#define W5_DEF_ENC_PIC_HEIGHT           240U
+#define W5_MIN_ENC_PIC_WIDTH            256U
+#define W5_MIN_ENC_PIC_HEIGHT           128U
+#define W5_MAX_ENC_PIC_WIDTH            8192U
+#define W5_MAX_ENC_PIC_HEIGHT           8192U
+#define W5_ENC_CODEC_STEP_WIDTH         8U
+#define W5_ENC_CODEC_STEP_HEIGHT        8U
+#define W5_ENC_RAW_STEP_WIDTH           32U
+#define W5_ENC_RAW_STEP_HEIGHT          16U
 
 //  application specific configuration
 #define VPU_ENC_TIMEOUT                 60000
